package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysDictionary;

import java.util.List;

/**
 * @Description : 字典服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-28 23:41
 * @Modify :
 **/
public interface ISysDictionaryService {

    /**
     * 添加字典
     * @param sysDictionary
     */
    void insertSysDictionary(SysDictionary sysDictionary);

    /**
     * 根据id删除字典
     * @param id
     */
    void deleteSysDictionaryById(String id);

    /**
     * 修改字典
     * @param sysDictionary
     */
    void updateSysDictionary(SysDictionary sysDictionary);

    /**
     * 查询所有字典信息
     * @return
     */
    List<SysDictionary> listSysDictionary();

    /**
     * 根据id查询字典信息
     * @param id
     * @return
     */
    SysDictionary getSysDictionaryById(String id);

    /**
     * 根据父级代码查询字典项信息
     * @param parentCode
     * @return
     */
    List<SysDictionary> findSysDictionaryByParentCode(String parentCode);

    /**
     * 字典复杂查询，分页，排序
     */
    ListPager querySysDictionaryByPager(SysDictionary sysDictionary, Pager pager);

    /**
     * 字典复杂查询，分页，排序
     */
    List<SysDictionary> findSysDictionaryByTop();
}
