package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.TaskTime;

import java.util.List;

/**
 * @Description : 定时任务业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.968
 * @Modify      :
 **/
public interface ITaskTimeService {

    /**
     * 修改数据
     * @param taskTime
     */
    void updateTaskTime(TaskTime taskTime);

    /**
     * 修改任务状态
     * @param id        任务ID
     * @param status    任务状态
     * @param user      当前会话用户
     */
    void updateTaskTimeStatus(String id, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteTaskTimeById(String id);

    /**
     *  新增数据
     * @param taskTime
     * @return
     */
    TaskTime insertTaskTime(TaskTime taskTime);

    /**
     * 查询所有数据
     * @return
     */
    List<TaskTime> listTaskTime();

    /**
     * 根据id 数据
     * @param id
     * @return
     */
    TaskTime getTaskTimeById(String id);
}
