package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ILogOperateService;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.LogOperate;
import cn.estsh.i3plus.pojo.platform.repository.LogOperateRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

/**
 * @Description : 操作日志服务接口实现
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 13:54
 * @Modify :
 **/
@Service
public class LogOperateService implements ILogOperateService {
    public static final Logger LOGGER = LoggerFactory.getLogger(LogOperateService.class);

    @Autowired
    public LogOperateRepository logOperateRDao;

    @Override
    public LogOperate insertLogOperate(LogOperate logOperate) {
        return logOperateRDao.insert(logOperate);
    }

    @Override
    public List<LogOperate> listLogOperate(LogOperate logOperate, Pager pager) {
        return logOperateRDao.findAll();
    }

    @Override
    public void deleteLogOperateById(long id) {
        logOperateRDao.deleteById(id);
    }

    @Override
    public void deleteLogOperateByIds(String[] ids) {
        for(String idStr : ids){
            logOperateRDao.deleteById(Long.parseLong(idStr));
        }
    }

    @Override
    public LogOperate getLogOperateById(long id) {
        System.out.println("id====" + id);
        List list = logOperateRDao.findAll();
        System.out.println(list.size());
        Optional optional = logOperateRDao.findById(id);
        if(optional != null) {
            System.out.println(optional);

            System.out.println(optional.get());
            return (LogOperate) optional.get();
        }else{
            return null;
        }
    }
}
