package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ITaskTimeExpressionService;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.platform.bean.TaskTimeExpression;
import cn.estsh.i3plus.pojo.platform.repository.TaskTimeExpressionRepository;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 定时任务时间表达式 业务逻辑实现
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-24 20:40
 * @Modify :
 **/
@Service
public class TaskTimeExpressionServiceImpl implements ITaskTimeExpressionService {

    public static final Logger LOGGER = LoggerFactory.getLogger(TaskTimeExpressionServiceImpl.class);

    @Autowired
    private TaskTimeExpressionRepository taskTimeRecordingRDao;

    @Override
    public void updateTaskTimeExpression(TaskTimeExpression taskTimeExpression) {
        LOGGER.info("定时任务时间表达式 Task_TIME_EXPRESSION :{}", taskTimeExpression);
        taskTimeRecordingRDao.update(taskTimeExpression);
    }

    @Override
    public void deleteTaskTimeExpressionById(String id) {
        LOGGER.info("定时任务时间表达式 Task_TIME_EXPRESSION :{}", id);
        taskTimeRecordingRDao.deleteById(Long.parseLong(id));
    }

    @Override
    public TaskTimeExpression insertTaskTimeExpression(TaskTimeExpression taskTimeExpression) {
        LOGGER.info("定时任务时间表达式 Task_TIME_EXPRESSION :{}", taskTimeExpression);
        return taskTimeRecordingRDao.insert(taskTimeExpression);
    }

    @Override
    public List<TaskTimeExpression> listTaskTimeExpression() {
        LOGGER.info("定时任务时间表达式 Task_TIME_EXPRESSION list");
        return taskTimeRecordingRDao.list();
    }

    @Override
    public TaskTimeExpression getTaskTimeExpressionById(String id) {
        LOGGER.info("定时任务时间表达式 Task_TIME_EXPRESSION :{}" ,id);
        return taskTimeRecordingRDao.getById(Long.parseLong(id));
    }

    @Override
    public ListPager queryTaskTimeExpressionByPager(TaskTimeExpression taskTimeExpression, Pager pager) {
        LOGGER.info("文件表达式 TaskTimeExpression taskTimeExpression:{}，Pager:{}",taskTimeExpression,pager);
        if(taskTimeExpression == null) {
            pager = PagerHelper.getPager(pager, taskTimeRecordingRDao.listCount());
            return new ListPager(taskTimeRecordingRDao.listPager(pager),pager);
        }else {
            String hqlPack = CoreHqlPack.packHqlSysFile(taskTimeExpression);
            pager = PagerHelper.getPager(pager, taskTimeRecordingRDao.findByHqlWhereCount(hqlPack));
            return new ListPager(taskTimeRecordingRDao.findByHqlWherePage(hqlPack + taskTimeExpression.orderBy(),pager),pager);
        }
    }
}
